<?php
// $Id: heartbeat.admin.inc,v 1.1.2.9 2008/11/22 15:35:20 stalski Exp $ 
// by Jochen Stals - ONE-agency - www.one-agency.be


/**
 * Function to maintain and administer heartbeat settings
 *
 * @return settingsform
 */
function heartbeat_admin_settings() {
  $form['heartbeat_enabled'] = array(
    '#title' => t('Do you want to enable the heatbeat?'),
    '#type' => 'checkbox',
    '#size' => 5,
    '#default_value' => variable_get('heartbeat_enabled',1)
  );
  return system_settings_form($form);
}

/**
 * Overview list of  heartbeat messages
 * This page must be viewed to make the messages 
 * appear in the database after a module is installed
 * as well as make them translatable 
 */
function heartbeat_messages_overview() {
  global $base_url;
  
  // Invoke a hook function of contributed modules 
  // so that their messages are known in the database
  heartbeat_gather_messages();
  
  // Fetch the heartbeat_messages
  $messages = heartbeat_messages();
  if(count($messages) <= 0) {
    return t('Sorry, no heartbeat messages yet');
  }
  foreach ($messages as $message) {    
    $message = (object) $message;
    $rows[] = array(
      $message->event,
      $message->description,
      $message->karma_index,
      l( t('edit'), $base_url."/admin/settings/heartbeat/messages/". $message->event) 
     );
  }
  $headers = array(t('Event'), t('Description'),t('Karma index'), t('Operations'));
  
  $intro = '<h2>Modules that describe heartbeat messages.</h2>';
  $intro.= '<p>These messages are passed to the translation function when parsed to view. This means that once theire are viewed, they are available for you to translate.</p>';
  $intro.= '<p>Altering these messages will clear the rules cache but that still is not enough. You will have to translate the new sentence if you are dealing with a multilingual site. </p>';
  $intro.= '<p><strong>Under each message is a description of which token replacements you can choose in your message.</strong></p>';
  
  return t($intro). theme('table', $headers, $rows);
  
}


/**
 * Function to maintain and administer heartbeat messages
 *
 * @return settingsform
 */
function heartbeat_messages_edit(&$form_state, $event='',$edit = array()) {
  
  $form = array();
  $form[$event] = array(
    '#type' => 'fieldset',
    '#title' => t($event),
    '#collapsible' => true,
    '#collapsed' => FALSE,
  );
  $result = db_query("SELECT * FROM {heartbeat_messages} WHERE event = '%s' LIMIT 1", $event);
  $message = db_fetch_object($result);
  $variables = heartbeat_decode_message_variables($message->variables);
  // the replacement of @ from # is only needed to view them like that. 
  // The actual implementation needs the # for partial message translations
  $form[$event]['message'] = array(
    '#type' => 'textarea',
    '#title' => t($message->description),
    '#cols' => 10,
    '#rows' => 1,
    '#default_value' => empty($edit['message']) ? $message->message : $edit['message'],
    '#prefix' => '<p>'.t('<strong>Token replacements you can use</strong>: <br />').str_replace("#","@", implode(', ', array_keys($variables))) . '.</p>'  , 
  ); 
  $form[$event]['event'] = array(
    '#type' => 'hidden',
    '#default_value' => empty($edit['event']) ? $event : $edit['event'],
  ); 
  $form[$event]['message_concat'] = array(
    '#type' => 'textarea',
    '#cols' => 10,
    '#rows' => 1,
    '#default_value' => empty($edit['message_concat']) ? $message->message_concat : $edit['message_concat'],
  ); 
  $form[$event]['karma_index'] = array(
    '#type' => 'textfield',
    '#title' => t('karma index'),
    '#required' => TRUE,
    '#default_value' => empty($edit['karma_index']) ? $message->karma_index : $edit['karma_index'],
  ); 
    
  $form['submit'] = array('#type' => 'submit', '#value' => t('Save'));
  if (isset($edit['event'])) {
    $form['delete'] = array('#type' => 'submit', '#value' => t('Delete'));
    $form['event'] = array('#type' => 'value', '#value' => $event);
  }
	  
  return $form;
}

/**
 * Accept the form submission heartbeat messages.
 */
function heartbeat_messages_edit_submit($form, &$form_state) {
  if($form_state['clicked_button']['#value'] == t('Save')) {    
   db_query("UPDATE {heartbeat_messages} SET message ='%s', message_concat ='%s', karma_index = %d 
   WHERE event = '%s'",
   $form_state['values']['message'],$form_state['values']['message_concat'],$form_state['values']['karma_index'], $form_state['values']['event']);
  }
  // Clear the rules cache to avoid problems
  rules_clear_cache();
  //$form_state['redirect'] = 'admin/settings/heartbeat/messages';
  drupal_set_message('Settings updated');
  return;
}